<template>
    <div>
        <el-form ref="form" :model="question" label-width="150px">
            <el-form-item label="Nội dung câu hỏi">
                <el-input type="textarea" v-model="question.content"></el-input>
            </el-form-item>

            <el-collapse v-model="activeNames">
                <el-collapse-item :title="'Đáp án số ' + (index + 1) " :name="(index + 1)" :key="index" v-for="(answer, index) in question.answers">
                    <el-row>
                        <el-col :span="20">
                            <el-input type="textarea" v-model="answer.content"></el-input>
                        </el-col>
                        <el-col :span="2">
                            <el-checkbox v-model="answer.correct" border></el-checkbox>
                        </el-col>
                        <el-col :span="2">
                            <el-button type="danger" icon="delete" size="mini" @click="removeAnswer(index)">Xóa</el-button>
                        </el-col>
                    </el-row>
                </el-collapse-item>
            </el-collapse>
            <el-row align="right">
                <el-button type="default" icon="plus" size="mini" @click="addAnswer()">Thêm câu trả lời</el-button>
            </el-row>

            <el-form-item align="center">
                <el-button type="primary" @click="validate">Lưu lại</el-button>
                <el-button>Hủy</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>

<script>
    export default {
        name: 'QuestionForm',
        props: {},
        data() {
            return {
                question: {
                    content: '',
                    answers: [
                        {
                            content: '',
                            correct: false,
                        },
                        {
                            content: '',
                            correct: false,
                        }
                    ]
                },
                activeNames: 1
            }
        },
        created() {
            if (this.$route.params.id) {
                this.showQuestion(this.$route.params.id);
            }
        },
        methods: {
            showQuestion(id) {
                this.$axios.get(`api/v1/questions/${id}`).then((res) => {
                    if (res.status === 200) {
                        this.question = res.data.question;
                    }
                }).catch((errors) => {
                    this.$message({type: 'error',message: errors.message});
                });
            },
            addAnswer() {
                this.question.answers.push({
                    content: '',
                    correct: false,
                })
            },
            removeAnswer(index) {
                if (this.question.answers.length <= 2) {
                    this.$message({type: 'warning', message: 'Tối thiểu phải 2 đáp án'});
                    return false;
                }

                this.question.answers.splice(index, 1);
            },
            validate() {
                this.createUpUpdateQuestion();
            },
            createUpUpdateQuestion() {
                if (this.$route.params.id) {
                    this.$axios.put(`api/v1/questions/${this.$route.params.id}`, this.question).then((res) => {
                        if (res.status === 200) {
                            this.$router.push({name: 'questions'});
                        }
                    }).catch((errors) => {
                        this.$message({type: 'error',message: errors.message});
                    });
                } else {
                    this.$axios.post(`api/v1/questions`, this.question).then((res) => {
                        if (res.status === 200) {
                            this.$router.push({name: 'questions'});
                        }
                    }).catch((errors) => {
                        this.$message({type: 'error',message: errors.message});
                    });
                }
            },
        }
    }
</script>

<style>
    
</style>